"{ Package: 'jv:vdb/plugins/bee' }"

"{ NameSpace: Smalltalk }"

VDBAbstractListApplication subclass:#BeeSymbolListApplication
	instanceVariableNames:'symbolListHolder selectedSymbolHolder filterHolder'
	classVariableNames:''
	poolDictionaries:'GDBStopReasons'
	category:'VDB-Plugin-Bee-UI'
!


!BeeSymbolListApplication class methodsFor:'accessing - defaults'!

defaultWindowTitle
    ^ 'Bee Symbols'

    "Modified: / 07-06-2019 / 15:00:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BeeSymbolListApplication class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:BeeSymbolListApplication andSelector:#windowSpec
     BeeSymbolListApplication new openInterface:#windowSpec
     BeeSymbolListApplication open
    "

    <resource: #canvas>

    ^ 
    #(FullSpec
       name: windowSpec
       uuid: '10cae1b0-8b8a-11e9-8967-606720e43e2c'
       window: 
      (WindowSpec
         label: 'VDBAbstractListApplication'
         name: 'VDBAbstractListApplication'
         uuid: '7601bfb1-8b88-11e9-8967-606720e43e2c'
         min: (Point 10 10)
         bounds: (Rectangle 0 0 300 300)
       )
       component: 
      (SpecCollection
         collection: (
          (InputFieldSpec
             name: 'EntryField1'
             layout: (LayoutFrame 0 0 0 0 0 1 25 0)
             uuid: '7601bfb2-8b88-11e9-8967-606720e43e2c'
             model: filterHolder
             immediateAccept: true
             acceptOnReturn: true
             acceptOnTab: true
             acceptOnPointerLeave: true
             emptyFieldReplacementText: 'Enter search pattern...'
             translateEmptyFieldReplacementText: true
             postBuildCallback: postBuildFilterView:
           )
          (SelectionInListModelViewSpec
             name: 'SelectionInListModelView1'
             layout: (LayoutFrame 0 0 25 0 0 1 0 1)
             uuid: '7601bfb3-8b88-11e9-8967-606720e43e2c'
             model: internalSelectionHolder
             menu: contextMenu
             hasHorizontalScrollBar: true
             hasVerticalScrollBar: true
             listModel: internalListHolder
             useIndex: false
             highlightMode: line
             doubleClickSelector: doDoubleClick
             selectConditionSelector: internalCanSelect:
             postBuildCallback: postBuildInternalListView:
           )
          )
        
       )
     )

    "Modified: / 10-06-2019 / 15:15:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BeeSymbolListApplication class methodsFor:'plugIn spec'!

aspectSelectors
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this. If it is corrupted,
     the UIPainter may not be able to read the specification."

    "Return a description of exported aspects;
     these can be connected to aspects of an embedding application
     (if this app is embedded in a subCanvas)."

    ^ #(
        #debuggerHolder
      ).

! !

!BeeSymbolListApplication methodsFor:'aspects'!

filterHolder
    "return/create the 'filterHolder' value holder (automatically generated)"

    filterHolder isNil ifTrue:[
        filterHolder := ValueHolder new.
        filterHolder addDependent:self.
    ].
    ^ filterHolder

    "Modified (format): / 10-06-2019 / 15:03:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

filterHolder:aValueHolder
    "set the 'filterHolder' value holder (automatically generated)"

    |oldValue newValue|

    filterHolder notNil ifTrue:[
        oldValue := filterHolder value.
        filterHolder removeDependent:self.
    ].
    filterHolder := aValueHolder.
    filterHolder notNil ifTrue:[
        filterHolder addDependent:self.
    ].
    newValue := filterHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:filterHolder.
    ].
!

selectedSymbolHolder
    "return/create the 'selectedSymbolHolder' value holder (automatically generated)"

    selectedSymbolHolder isNil ifTrue:[
        selectedSymbolHolder := ValueHolder new.
        selectedSymbolHolder addDependent:self.
    ].
    ^ selectedSymbolHolder
!

selectedSymbolHolder:something
    "set the 'selectedSymbolHolder' value holder (automatically generated)"

    |oldValue newValue|

    selectedSymbolHolder notNil ifTrue:[
        oldValue := selectedSymbolHolder value.
        selectedSymbolHolder removeDependent:self.
    ].
    selectedSymbolHolder := something.
    selectedSymbolHolder notNil ifTrue:[
        selectedSymbolHolder addDependent:self.
    ].
    newValue := selectedSymbolHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:selectedSymbolHolder.
    ].
!

symbolListHolder
    "return/create the 'symbolListHolder' value holder (automatically generated)"

    symbolListHolder isNil ifTrue:[
        symbolListHolder := ValueHolder new.
        symbolListHolder addDependent:self.
    ].
    ^ symbolListHolder
!

symbolListHolder:something
    "set the 'symbolListHolder' value holder (automatically generated)"

    |oldValue newValue|

    symbolListHolder notNil ifTrue:[
        oldValue := symbolListHolder value.
        symbolListHolder removeDependent:self.
    ].
    symbolListHolder := something.
    symbolListHolder notNil ifTrue:[
        symbolListHolder addDependent:self.
    ].
    newValue := symbolListHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:symbolListHolder.
    ].
! !

!BeeSymbolListApplication methodsFor:'change & update'!

update:aspect with:param from:sender
    "Invoked when an object that I depend upon sends a change notification."

    sender == symbolListHolder ifTrue:[
        self enqueueDelayedUpdateInternalList.
        ^ self.
    ].
    sender == filterHolder ifTrue:[ 
        self enqueueDelayedUpdateInternalList.
        ^ self.
    ].
    super update:aspect with:param from:sender

    "Created: / 07-06-2019 / 15:05:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2019 / 15:05:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BeeSymbolListApplication methodsFor:'change & update-delayed'!

delayedUpdateContents
    | symbols |

    debugger notNil ifTrue:[
        debugger send: GDBMI_bee_list_symbols new andWithResultDo: [ :result |
            result isDone ifTrue:[
                symbols := result propertyAt: #result.
                symbols do:[:e | e setDebugger: debugger ].
                symbols sort:[ :a :b | a name < b name ].
                self symbolListHolder value: symbols.
            ].
        ]
    ] ifFalse:[ 
        self symbolListHolder value: nil.
    ].

    "Created: / 07-06-2019 / 14:59:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2019 / 10:31:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

delayedUpdateInternalList
    | symbols symbolPs |

    symbols := self symbolListHolder value ? #().
    self filterHolder value notEmptyOrNil ifTrue:[
        | filter |

        filter := StringPattern fromString: filterHolder value.
        symbols := symbols select: [:symbol | filter match: symbol name relax: 1].
        symbols isEmpty ifTrue:[ 
            symbols := self symbolListHolder value ? #().    
            symbols := symbols select: [:symbol | filter match: symbol name relax: 2].
        ].
        symbols isEmpty ifTrue:[ 
            symbols := self symbolListHolder value ? #().    
            symbols := symbols select: [:symbol | filter match: symbol name relax: 3].
        ].
    ].
    symbolPs := symbols collect:[ :reg | BeeSymbolPresenter new setSymbol: reg ].
    self internalListHolder value: symbolPs

    "Modified: / 10-06-2019 / 15:18:28 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

delayedUpdateSelection
    | symbolP |

    symbolP := self internalSelectionHolder value.    
    self selectedSymbolHolder value: (symbolP notNil ifTrue:[ symbolP symbol ] ifFalse:[ nil ])

    "Modified (format): / 07-06-2019 / 15:07:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BeeSymbolListApplication methodsFor:'event handling'!

onBreakpointEvent: aGDBBreakpointModifiedEvent
    self enqueueDelayedInvalidateInternalList

    "Created: / 10-06-2019 / 15:49:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

onStoppedEvent: aGDBStoppedEvent

    aGDBStoppedEvent reason ~= EndSteppingRange ifTrue:[ 
        self enqueueDelayedUpdateContents
    ].

    "Created: / 10-06-2019 / 14:12:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BeeSymbolListApplication methodsFor:'hooks'!

postBuildFilterView: aView
    aView font: self textFont

    "Modified: / 10-06-2019 / 15:14:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BeeSymbolListApplication methodsFor:'initialization & release'!

subscribe
    super subscribe.
    debugger notNil ifTrue:[ 
        debugger announcer 
            when: GDBStoppedEvent       send: #onStoppedEvent:      to: self;
            when: GDBBreakpointEvent    send: #onBreakpointEvent:   to: self
    ]

    "Created: / 10-06-2019 / 14:12:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2019 / 15:49:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BeeSymbolListApplication class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

